function [CAMul AIC] = getCAMul(de)
%I think this is OK, but have nothing to check it against
% The Central Age Model

% Requires 2 cols of De with errors
%de=delist; %name of the data in workspace
sigma=0.10; %starting value for OD

%dat=[log(de(:,1)); de(:,2)./de(:,1)]; % format data into 1 vector, need for passing to mle
dat=[de(:,1); de(:,2)]; % format data into 1 vector, need for passing to mle

% mle: alpha sets the confidence interval e.g. 0.05 for 95%
[ests ci68]=mle(dat,'nloglf',@neglogCAMul,'start',sigma,'alpha',0.32); % use mle to find sigma
w=1./(ests^2+(de(:,2)./de(:,1)).^2); %the weights
cen_age=sum(w.*de(:,1))/sum(w); %the central age
cen_err=sum(w)^-0.5*cen_age;
OD=ests;
OD_err=(2*OD^2*sum(w.^2))^-0.5;
CAMul=[cen_age cen_err OD OD_err];
loglike=-neglogCAMul(ests,dat);
BIC=-2*loglike+1*log(length(de(:,1)));
AIC=-2*loglike+2*1;
end

function L0 = neglogCAMul(param,dat,cens,freq)
%the negative log likelihood function for the central age model

n=length(dat)/2;
yu=dat(1:n,1);
su=dat(n+1:2*n);
sigma=param;
%negloglik
wu=1./((sigma*yu).^2 + su.^2);
rwu=sqrt(wu);

mu0=sum(wu.*yu)/sum(wu);
fu0=rwu.*exp(-0.5*wu.*(yu-mu0).^2);
L0=-sum(log((1/sqrt(2*pi)).*fu0));
end